package PureMessage::Manager::Response::ServerGroups::Publications;
use PureMessage::ServerGroup::Publication;
use base 'Exporter';
use PureMessage::Manager::Widget;
use vars qw(@EXPORT_OK);
our @EXPORT_OK = qw(Publish);
                                        
sub List {
    my $RESPONSE = shift;
    my @menu;
    foreach ( PureMessage::ServerGroup::Publication::get_all() ) {
        push @menu, { type=>'text', text=>$_->{name}, href=>"/ServerGroups/publication.cgi?id=$_->{name}" };
    }
    my $top_tb = button({type=>'image', 
                         icon=>'add_plus',
                         text=>"New", 
                         href=>"/ServerGroups/publication.cgi" }, style=>"reverse");
#    push @menu, { type=>'text', text=>"Create new", href=>"/ServerGroups/publication.cgi" };
    $RESPONSE->add_taskmenu({ title => 'Publications', buttons => [ \@menu ], tb=>$top_tb });
#    $RESPONSE->add_taskmenu({ title => 'Publications', buttons => [ \@menu ]});
}

sub Publish {
    my $file = shift;
    my $description = shift;
    my %opts = @_;
    $file = [$file] unless ref($file) eq "ARRAY";
    return unless @$file;
    my $obj_type = exists($opts{'obj_type'}) ? $opts{'obj_type'} : "file";
    my @menu;
    my @pub;
    foreach my $f (@$file) {
        if (my $shared = PureMessage::ServerGroup::Publication::is_shared($f)) {
            push @pub, $shared;
        }
    }
    if ( @pub ) {
        my $p = PureMessage::ServerGroup::Publication->new(shift @pub);
        my $s = keys %{$p->subscribers()};
        return InfoBox(<<EOT);
<b>This configuration is 
<a href="/ServerGroups/publication.cgi?id=$p->{name}">shared</a></b>: 
$s subscriber(s)
EOT
    }
    else {
        my $menu;
        foreach ( PureMessage::ServerGroup::Publication::get_all() ) {
            $menu .= "<option value='$_->{name}'>$_->{name}</option>\n";
        }
        my $uid = time();
        my $files_form = "";

        foreach my $f (@$file) {
            $files_form .= "<input type=hidden name='$obj_type' value='$f'>";
        }
        my $html = InfoBox(<<EOT);
<table cellpadding=0 cellspacing=0>
<tr>
<td>
    <b>You can publish this configuration to other hosts:</b>&nbsp;
</td>
<td>
  $files_form
  <input type=hidden name='file_desc' value='$description'>
  <input type=hidden name='name' value='Publication_$uid'>
  <select name=id>
    <option value="">(select publication)</option>
    $menu
    <option value="">Create New...</option>
  </select>
</td>
<td>&nbsp;<input type=submit value="Share" class=button></td>
</tr>
</table>
EOT
        $html = <<EOT;
        <form action="/ServerGroups/publication.cgi" style="padding: 0px 0px 0px 0px;">
        $html
        </form>
EOT
        return $html;
    }
}

sub InfoBox {
    return <<EOT;
    <table cellpadding=4 cellspacing=0 width="100%">
    <tr>
    <td width="1" class="infoBox">
        <img src="/img/share.gif">
    </td>
    <td class="infoBox">@_</td>
    </tr></table>
EOT
}

1;
